//
//  TCGBAnalyticsLevelUpData.h
//  Gamebase
//
//  Created by NHNEnt on 21/11/2018.
//  Copyright © 2018 NHN Entertainment Corp. All rights reserved.
//
#import <Foundation/Foundation.h>

#ifndef TCGBAnalyticsLevelUpData_h
#define TCGBAnalyticsLevelUpData_h

@interface TCGBAnalyticsLevelUpData : NSObject

// Property
@property (nonatomic, assign) int userLevel; // Required.
@property (nonatomic, assign) long long levelUpTime; // Optional. Default value is -1. epochTime in millis. Accept only positive values.
@property (nonatomic, strong, nullable) NSString* channelId; // Optional. Default value is nil.
@property (nonatomic, strong, nullable) NSString* characterId; // Optional. Default value is nil.

// Initializer
- (nonnull instancetype)init __attribute__((unavailable("Must use initWithUserLevel: instead.")));
- (nonnull instancetype)initWithUserLevel:(int)userLevel;
+ (nonnull instancetype)levelUpDataWithUserLevel:(int)userLevel;

// for iOS Only
- (void)setLevelUpTimeWithDate:(nonnull NSDate *)now; // Convert NSDate to epoch time and set levelUpTime.

@end

#endif /* TCGBAnalyticsLevelUpData_h */
